package sebastianmeier;
public class PolarPoint{

	float theta;
	float radius;
	
	public PolarPoint() {
		this(0,0);
	}
	public PolarPoint(float theta, float radius) {
		this.theta = theta;
		this.radius = radius;
	}
	public float getTheta() { return theta; }
	public float getRadius() { return radius; }
	public void setTheta(float theta) { this.theta = theta; }
	public void setRadius(float radius) { this.radius = radius; }

	/**
	 * Returns the result of converting <code>polar</code> to Cartesian coordinates.
	 */
	public static float[] polarToCartesian(PolarPoint polar) {
		return polarToCartesian(polar.getTheta(), polar.getRadius());
	}

	/**
	 * Returns the result of converting <code>(theta, radius)</code> to Cartesian coordinates.
	 */
	public static float[] polarToCartesian(int theta, int radius) {
		float returnFloat[] = new float[2];
		returnFloat[0] = (float) (radius*Math.cos(theta));
		returnFloat[1] = (float) (radius*Math.sin(theta));
		return returnFloat;
	}

	public static float[] polarToCartesian(float theta, float radius) {
		float returnFloat[] = new float[2];
		returnFloat[0] = (float) (radius*Math.cos(theta));
		returnFloat[1] = (float) (radius*Math.sin(theta));
		return returnFloat;
	}

	/**
	 * Returns the result of converting <code>point</code> to polar coordinates.
	 */
	public static PolarPoint cartesianToPolar(int x, int y) {
		return cartesianToPolar(x, y);
	}

	/**
	 * Returns the result of converting <code>(x, y)</code> to polar coordinates.
	 */
	public static PolarPoint cartesianToPolar(float x, float y) {
		float theta = (float) Math.atan2(y,x);
		float radius = (float) Math.sqrt(x*x+y*y);
		return new PolarPoint(theta, radius);
	}
	
	public String toString() {
		String superString = super.toString();
		return superString.replace("Point2D", "PolarPoint2D");
	}
	
	public void setLocation(PolarPoint p) {
		this.theta = (float) p.getTheta();
		this.radius = (float) p.getRadius();
	}

}
